<?php

/*
 * audit_log parser
 * modseclogwatch v0.0.3
 * based on parser @ http://www.hackinthebox.org/article.php?sid=12867
 * (c) Evert Daman, evert@digipix.org
 *
 */
 
	$audit_log_dir = "/var/log/httpd/audit_log";
	$verbose = "on";	// currently just display the number of records inserted

	//database information
	$dbhost = "localhost";
	$dbuser = "modsecurity";
	$dbpassword = "";
	$dbname = "modsecurity";
	$tblname = "user_detail";

	$tmpfname = tempnam("/var/log/httpd/", "Temp");
	if (!copy($audit_log_dir, $tmpfname)) {
		echo "failed to copy...<br>";
	}

	// uncomment to remove old audit_log
	//$clear = tempnam("/var/log/httpd/","Clear");
	//if (!copy($clear, $audit_log_dir)) {
 	//	echo "failed to copy...<br>";
   	//}

	//set time limit to infinite & initialize counter=0
	set_time_limit(0);
	$counter = 0;

	//open target file
	$file = fopen ($tmpfname, "r");
	
	//exit if target file does not exist or unable to open
	if (!$file) {
    	echo "Unable to open remote file.\n";
    	exit;
	}

	$link = mysql_connect("$dbhost", "$dbuser", "$dbpassword")
		or die("Unable to connect MySQL");
	$db = mysql_select_db("$dbname",$link)
		or die("unable open database");

	//loop until end of file
	while (!feof($file)){
	
		//get the first word of line n
		$firstword = read_until($file, " ");

		//get all information between the double-lines
		while (!strstr($firstword, "========") && !feof($file)) {

			//assign values to variable if firstword matches a wanted field
			if($firstword == "Request:" || $firstword == "Handler:" || $firstword == "Accept:"
					|| $firstword == "Accept-Encoding:" || $firstword == "Accept-Language:"
					|| $firstword == "Connection:" || $firstword == "Host:"
					|| $firstword == "User-Agent:" || $firstword == "X-Powered-By:"
					|| $firstword == "Via:" || $firstword == "X-Forwarded-For:"
					|| $firstword == "Transfer-Encoding:" || $firstword == "Content-Type:"
					|| $firstword == "Referer:" || $firstword == "If-Modified-Since:"
					|| $firstword == "Last-Modified:" ||$firstword == "Cookie:"
					|| $firstword == "ETag:" || $firstword == "If-None-Match:"
					|| $firstword == "Accept-Ranges:" || $firstword=="Error:"
					|| $firstword == "mod_security-message:" || $firstword=="mod_security-action:" 
					|| $firstword == "Content-Length:" ){
	
				switch ($firstword){
					case "Request:":
						// get user_ip
						$user_ip = read_until($file, " ");
						read_until($file, "[");
						
						// get time and date
						$day = read_until($file, "/");					
						$month = read_until($file, "/");
						$year = read_until($file, ":");					
						$time = read_until($file, "]");
						// strip time-offset (+0200 in our case) to work around a bug
						// that 20:0x is put in the dbase as 2:00:00
						if (substr($time, -5, 1) == "+") {
							$time = substr($time, 0, 8);
						}

						$mon = chmonth($month);
						$date =$year."-".$mon."-".$day;
						read_until($file, "\"");
					   
						$request_method = read_until($file, " ");
						
						$php_self = read_until($file, " ");
						
						$server_protocol = read_until($file, "\"");
						pointer_forward($file,1);
						
						$redirect_status = read_until($file, " ");
						
						$content_length = read_until($file, " ");
	
						break;
						
					case "Handler:":
						$handler = read_until($file, " ");
						break;
						
					case "Accept:":
						$accept = read_until($file, "\n");
						break;
						
					case "Accept-Ranges:":
						$accept_ranges = read_until($file, "\n");
						break;
						
					case "Accept-Encoding:":
						$accept_encoding = read_until($file, "\n");
						break;
						
					case "Accept-Language:":
						$accept_language = read_until($file, "\n");
						break;
						
					case "Connection:":
						$connection = read_until($file, "\n");
						break;
						
					case "Host:":
						$host = read_until($file, "\n");
						break;
						
					case "User-Agent:":
						$user_agent = read_until($file, "\n");
						break;
	
					case "Via:":
						$via = read_until($file, "\n");
						break;
	
					case "X-Forwarded-For:":
						$x_forwarded_for = read_until($file, "\n");
						break;
																
					case "X-Powered-By:":
						$x_powered_by = read_until($file, "\n");
						break;
						
					case "Transfer-Encoding:":
						$transfer_encoding = read_until($file, "\n");
						break;
						
					case "Content-Type:":
						// opletten! content-type wordt dubbel gegeven bij POST, en dan
						// moeten we alleen de eerste pakken
						if ($content_type == "") {
							$content_type = read_until($file, "\n");
						}
						break;
						
					case "Referer:":
						$referer = read_until($file, "\n");
						break;
						
					case "If-Modified-Since:":
						$if_modified_since = read_until($file, "\n");
						break;
						
					case "Last-Modified:":
						$last_modified = read_until($file, "\n");
						break;
	
					case "Cookie:":
						$cookie = read_until($file, "\n");
						break;
						
					case "ETag:":
						$etag = read_until($file, "\n");
						break;
						
					case "Error:":
						$error=read_until($file,"\n");
						break;
						
					case "mod_security-message:":
						$mod_security_message=read_until($file,"\n");
						break;
						
					case "mod_security-action:":
						$mod_security_action=read_until($file,"\n");
						break;
	
					case "If-None-Match:":
						$if_none_match = read_until($file, "\n");
						break;
						
					case "Content-Length:":
						// deze is bij POST nog een x ecpliciet vermeld... dus die laatste nemen
						// we mee (anders pakken we die bij de request-methode regel)
						$content_length = read_until($file, "\n");
						break;
				}
			} else {
				// hoorde nergens bij.... niet bij de standaards in elk geval... misschien was het POST?
				// dan zou het de payload kunnen zijn dus daar voegen we hem maar aan toe (moet dan wel iets
				// zijn wat na 'mod_security-action' komt!) ($post_payload setten we 1 regel (das alles) en daarna
				// niets meer voor deze log-item)
				if ($request_method == "POST" && strstr($mod_security_message, "POST_PAYLOAD") && $mod_security_action != "" && $post_payload == "") {
					// alles tot aan de volgende line toevoegen
					// $firstword bevat nu de content-length... we moeten dus 1 regel verder
					read_until($file, "\n");
					$post_payload .= read_until($file, "\n");
				}
			}
			
			// get the next line (for this log-item
			$firstword = read_until($file, " ");				
		}
	
		// all information for this log-item is read, so add to dbase
		if ($user_ip != "") {

			$user_ip 	= mysql_escape_string($user_ip);
			$date 		= mysql_escape_string($date);
			$time		= mysql_escape_string($time);
			$request_method 	= mysql_escape_string($request_method);
			$accept 	= mysql_escape_string($accept);
			$accept_ranges 		= mysql_escape_string($accept_ranges);
			$accept_encoding 	= mysql_escape_string($accept_encoding);
			$accept_language 	= mysql_escape_string($accept_language);
			$connection 	= mysql_escape_string($connection);
			$host 		= mysql_escape_string($host);
			$referrer 	= mysql_escape_string($referrer);
			$user_agent	= mysql_escape_string($user_agent);
			$via = mysql_escape_string($via);				
			$x_forwarded_for = mysql_escape_string($x_forwarded_for);
			$php_self	= mysql_escape_string($php_self);
			$server_protocol 	= mysql_escape_string($server_protocol);
			$content_length		= mysql_escape_string($content_length);
			$handler	= mysql_escape_string($handler);
			$redirect_status	= mysql_escape_string($redirect_status);
			$if_modified_since 	= mysql_escape_string($if_modified_since);
			$last_modified		= mysql_escape_string($last_modified);
			$cookie		= mysql_escape_string($cookie);
			$etag		= mysql_escape_string($etag);
			$if_none_match	= mysql_escape_string($if_none_match);
			$x_powered_by	= mysql_escape_string($x_powered_by);
			$transfer_encoding	= mysql_escape_string($transfer_encoding);
			$error		= mysql_escape_string($error);
			$mod_security_message 	= mysql_escape_string($mod_security_message);
			$mod_security_action	= mysql_escape_string($mod_security_action);
			$content_type	= mysql_escape_string($content_type);
			$post_payload = mysql_escape_string($post_payload);


			$sql = "insert into $tblname
					(user_ip, date, time, request_method, accept, accept_ranges,
					accept_encoding, accept_language, connection, host, referer,
					user_agent, via, x_forwarded_for, php_self, server_protocol, 
					content_length, handler, redirect_status, if_modified_since,
					last_modified, cookie, etag, if_none_match, x_powered_by, 
					transfer_encoding, error, mod_security_message, 
					mod_security_action, content_type, post_payload)
					values ('$user_ip','$date','$time','$request_method','$accept',
							'$accept_ranges','$accept_encoding','$accept_language',
							'$connection','$host','$referer','$user_agent', 
							'$via', '$x_forwarded_for', '$php_self','$server_protocol',
							'$content_length', '$handler','$redirect_status',
							'$if_modified_since', '$last_modified','$cookie','$etag',
							'$if_none_match', '$x_powered_by','$transfer_encoding',
							'$error','$mod_security_message', '$mod_security_action',
							'$content_type', '$post_payload')" ;
			$sql_result = mysql_query($sql,$link);
			if (!$sql_result) {
				echo mysql_error();
			}
			// en de teller eentje ophogen
			$counter++;
		}
		
		// reset variable after a logitem has been read (ready for next one)
		$user_ip="";
		$date="";
		$day="";
		$month="";
		$mon="";
		$year="";
		$time="";
		$request_method="";
		$php_self="";
		$server_protocol="";
		$redirect_status="";
		$content_length="";
		$handler="";
		$accept="";
		$accept_encoding="";
		$accept_language="";
		$accept_ranges="";
		$connection="";
		$host="";
		$user_agent="";
		$via="";
		$x_forwarded_for="";
		$x_powered_by="";
		$transfer_encoding="";
		$content_type="";
		$referer="";
		$if_modified_since="";
		$last_modified="";
		$cookie="";
		$etag="";
		$if_none_match="";
		$error="";
		$mod_security_message="";
		$mod_security_action="";
		$post_payload="";
	}

	if ($verbose == "on") {
		echo "[+] $counter records inserted into database\n";
	}
	fclose($file);
	// troep opruimen
   	//unlink($clear);
	unlink($tmpfname); 
	mysql_close($link);
?>

<?php

function chmonth($mon){
	switch($mon){
		case 'Jan':
		    $month='01';
		    break;
		case 'Feb':
		    $month='02';
		    break;
		case 'Mar':
		    $month='03';
		    break;
		case 'Apr':
		    $month='04';
		    break;
		case 'May':
		    $month='05';
		    break;
		case 'Jun':
		    $month='06';
		    break;
		case 'Jul':
		    $month='07';
		    break;
		case 'Aug':
		    $month='08';
		    break;
		case 'Sep':
		    $month='09';
		    break;
		case 'Oct':
		    $month='10';
		    break;
        case 'Nov':
		    $month='11';
		    break;
		case 'Dec':
		    $month='12';
		    break;
		default:
			$month='00';

	}
	return $month;
}

//this function return a string that start from current pointer until the
//nearest $punc
function read_until($file, $punc){
	for($char=fgetc($file);$char!=$punc && !feof($file) && $char!="\n"; $char=fgetc($file))
		$result .= $char;
 	return ($result);
}

//$num move(s) to a current file pointer
function pointer_forward($file, $num){
	fseek($file, $num, SEEK_CUR);
	return ($file);
}
?>
